package school_project.Utils;

import javafx.scene.Node;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.GridPane;
import javafx.scene.paint.Color;
import javafx.scene.paint.Paint;
import javafx.scene.shape.Rectangle;
import org.checkerframework.common.reflection.qual.GetClass;
import school_project.Controller;
import school_project.GameUI;
import school_project.Shape;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;

public class MatrixShape extends GridPane {
    public MatrixShape(Shape shape, boolean texture) throws FileNotFoundException {
        super();
        setHgap(GameUI.SPACE_SIZE);
        setVgap(GameUI.SPACE_SIZE);
        boolean[][] shape_matrix = shape.getShape();
        for (int i = 0; i < shape_matrix.length; i++) {
            for (int j = 0; j < shape_matrix[i].length; j++) {
                if(shape_matrix[i][j]){
                    Node _cell = texture ? new ImageView(new Image(new FileInputStream(Controller.class.getResource("tile.png").getFile()))) : new Rectangle(GameUI.SEGMENT_SIZE, GameUI.SEGMENT_SIZE);
                    add(_cell, j, i);
                }
            }
        }
    }

    public void setColor(Paint p) {
        getChildren().forEach(node -> {
            if(node instanceof Rectangle r){
                r.setFill(p);
                r.setStroke(Color.BLACK);
            }
        });
    }
}
